Count Subarray sum Equals K | Brute - Better -Optimal

Поделиться
HTML-код
  • Опубликовано: 16 июл 2024
  • Problem Link: bit.ly/3Kn10eZ
    Please watch this video before watching this one: • Longest Subarray with ...
    Notes/C++/Java/Python codes: takeuforward.org/arrays/count...
    We have solved the problem, and we have gone from brute force and ended with the most optimal solution. Every approach's code has been written in the video itself. Also, we have covered the algorithm with intuition.
    Full Course: bit.ly/tufA2ZYt
    You can follow me across social media, all my handles are below:
    Linkedin/Instagram/Telegram: linktr.ee/takeUforward
    00:00 Intro
    01:03 Problem Statement
    01:13 Sub-array definition
    01:52 Example
    03:13 Brute force solution
    06:07 Complexity
    06:29 Better solution
    08:07 Complexity
    08:21 Optimal Solution
    08:41 Prefix sum concept
    09:35 Thought process
    13:55 Dry run
    21:22 Code
    22:38 Complexity

Комментарии • 225

  • @itzmartin20
    @itzmartin20 10 месяцев назад +114

    When I first started DSA, I was just so scared of the code and knowing very little about the logic and the intuition behind but Striver you are the one who has ever showed the completely difference - Extreme natural approach and observation and crystal clear logic. You've made the coding fun and interesting toward people like me. Hats off for your dedication! Understood!

    • @utkarshverma3314
      @utkarshverma3314 10 месяцев назад +3

      i am doing his dsa sheet , the array part and almost every question has a completely different logic and approach and its becoming quite frustrating as im not able to come up with the solutions so do i just keep solving more problems or am i doing something wrong

    • @anshlyk
      @anshlyk 10 месяцев назад

      keep going! I was in the same boat, you'll slowly be able to form logic@@utkarshverma3314

    • @akworld2739
      @akworld2739 9 месяцев назад

      @@utkarshverma3314 same problem i am also facing

    • @VivekKumar-kx2zf
      @VivekKumar-kx2zf 3 месяца назад

      ashishbhattacharyya yup, it works for me.

    • @Sankalp-sd6fm
      @Sankalp-sd6fm 2 месяца назад

      could you please tell if i should make notes ?? how do i make them so that i dont put hours in it

  • @daayush6654
    @daayush6654 Год назад +30

    I saw this video at around 10 am in college, was only able to think of o(n²) solution, I took the pause at your hint of using prefix sum array, kept thinking for some time while in college lectures but was able to get the solution at around 6pm 😝, I know it took time but it felt good to actually think of the solution, please keep up the consistency

  • @andrewcenteno3462
    @andrewcenteno3462 Год назад +27

    This man is my hero, I struggled so much with this question to visualize it and subsequent problems like it. I've done ove 270 LC questions, but this man made it so simple

  • @AyushVerma-wu3nn
    @AyushVerma-wu3nn 10 месяцев назад +7

    Just when I think the video is getting long enough for a simple problem,
    I go search the web and find not a single tutor with such a powerful explanation!

  • @AnuroopLSabu-mp8wm
    @AnuroopLSabu-mp8wm 11 месяцев назад +4

    Its really amazing that you are taking your time in explaining via the dry run. It helps me a lot. Thanks :)

  • @abhijeetmishra3804
    @abhijeetmishra3804 9 месяцев назад +5

    understood bhaiya . You can not even imagine how much people love u and praise you and speak about your videos all the time. I am sure u get hiccups every now and then . Live long bhaiya u are our real teacher.

  • @Anurag-fk3op
    @Anurag-fk3op 3 месяца назад +10

    16:29 if we write if(sum==k) count++
    We don't need to include 0 at beginning

  • @sujeet4410
    @sujeet4410 3 месяца назад +3

    This explanation is so 100x better than Neetcode's. Thank you !!!

  • @cinime
    @cinime Год назад +1

    Understood! Super fantastic explanation as always, thank you very very much for your effort!!

  • @alishashaikh3859
    @alishashaikh3859 10 месяцев назад +1

    Thank you so much. I saw many other youtuber's video but this video is the best . I was able to understand after watching this video for 2 times

  • @user-yb1es6mu8g
    @user-yb1es6mu8g 10 месяцев назад +1

    Amazingly Understood, Thank you for such a in depth thought process

  • @gamerversez5372
    @gamerversez5372 Год назад +8

    Instead of adding 0 in the hashmap, we can just use the statement if(sum==k) ans++; That works fine.
    See the Below Code
    int subarraySum(vector& nums, int k)
    {
    int ans=0;
    unordered_map x;

    int sum=0;

    for(int i=0;i

    • @00RohitRoshan
      @00RohitRoshan 11 месяцев назад +2

      very good .

    • @00RohitRoshan
      @00RohitRoshan 11 месяцев назад +1

      ` if(x.find(sum-k)!=x.end()) ans+=x[sum-k]; `
      And why this check before incrementing and.
      class Solution {
      public:
      int subarraySum(vector& nums, int k)
      {
      int ans=0,sum=0;
      unordered_map x;
      for(int i=0;i

    • @kushalswarup2662
      @kushalswarup2662 10 месяцев назад

      brilliant

    • @viralshah1014
      @viralshah1014 21 час назад

      @@00RohitRoshan map initially doesnt contain anything, so how would it add x[sum-k] in the first iteration? consider arr=[1] and k=1

  • @user-fn2jg7ng7q
    @user-fn2jg7ng7q 11 месяцев назад +1

    I saw many times but I couldn't understand...But now i finally understood and realised that ur explaination is too good...!

  • @aryansinha1818
    @aryansinha1818 Год назад +21

    You have given more than anyone can ask for. Thank you for all your support and such amazing videos. They are really helpful. Just a small thing can we have a dark mode setting for "take you forward" pages.

    • @takeUforward
      @takeUforward  Год назад +21

      You can build one chrome extension may be ;)

    • @dom47
      @dom47 Год назад +21

      appreciates striver by telling "u have given more than anyone can ask" and proceeds to place demand .

    • @yashjoon3889
      @yashjoon3889 Год назад +4

      @@takeUforward lol would be a good project for the resume?

    • @manvinmusic9239
      @manvinmusic9239 Год назад +3

      striver actually give the dark mode option

  • @puneetnj
    @puneetnj 11 месяцев назад +15

    So here, if in the question it is stated that it contains only positive as in codestudio then we can apply 2-pointer(Sliding window) as done in longest subarray with sum k. TC: O(N) SC: O(1)
    Else, if it contains both positive and negative HashMap is optimal

  • @Manishgupta200
    @Manishgupta200 Год назад +6

    That's really amazing 🤩Striver! code is too sort but logic is superb for the optimal. from brute (TC-> O(N^2), SC -> O(1)) to optimal (TC -> O(N) when using unordered_map, O(N * log N) when using ordered map, SC -> O(N) for using map data structure.

  • @vidhanshuborade5977
    @vidhanshuborade5977 Год назад +2

    Excellent explanation, understood ! ✨

  • @rushabhajain3977
    @rushabhajain3977 8 месяцев назад +1

    Excellent explanation yaar! Great to see such kind of explanations that guide from brute force to optimised solution in such a detail! Thank you so much and keep making such great videos :)

  • @vishnupandey3390
    @vishnupandey3390 11 месяцев назад

    thanks striver you have really explained this so well
    god bless you
    you are a wonderful teacher for many 🙏🙏

  • @davidmwangi4312
    @davidmwangi4312 Месяц назад

    Struggled to understand this solution, now understood, Keep up the great work Striver

  • @infernogamer52
    @infernogamer52 Год назад +2

    Understood Bhaiya! This was a tough one to understand for me...will soon revisit it
    Thank you🙏

  • @krishnavamsiyerrapatruni5385
    @krishnavamsiyerrapatruni5385 Год назад +1

    Understood. Thank you so much!

  • @varunpalsingh3822
    @varunpalsingh3822 Год назад +1

    Really good explanation & kudos to efforts, understood 👍

  • @dayashankarlakhotia4943
    @dayashankarlakhotia4943 Год назад +1

    Previous explanation and current explanation is good .understood

  • @AmanThakur-ve6ji
    @AmanThakur-ve6ji Год назад +1

    God for beginner❤hats of u bhaiya

  • @pulkitgupta669
    @pulkitgupta669 10 месяцев назад +1

    Understood Striver ❤. You are a living legend sir. 🤩🤩

  • @bpratikvinod8110
    @bpratikvinod8110 2 месяца назад +1

    The sliding window approach actually performs better with O(n) time complexity.
    int subarraySum(vector& nums, int sum) {
    int count = 0;
    int currSum = 0;
    unordered_map sumFreq;
    for (int i = 0; i < nums.size(); ++i) {
    currSum += nums[i];
    if (currSum == sum)
    count++;
    if (sumFreq.find(currSum - sum) != sumFreq.end())
    count += sumFreq[currSum - sum];
    sumFreq[currSum]++;
    // If currSum becomes greater than sum,
    // subtract elements from the start
    while (currSum > sum) {
    currSum -= nums[i - count + 1];
    sumFreq[currSum]--;
    if (sumFreq[currSum] == 0)
    sumFreq.erase(currSum);
    count--;
    }
    }
    return count;
    }

  • @sukhpreetsingh5200
    @sukhpreetsingh5200 Год назад

    Understood💖amazing explanation

  • @sauravchandra10
    @sauravchandra10 Год назад

    Understood, thanks!

  • @mehulthuletiya5638
    @mehulthuletiya5638 Год назад +10

    Timestamps
    01:03 - Problem Statement
    01:13 - Sub-array definition
    01:52 - Example
    03:13 - Brute force solution
    06:07 - Complexity
    06:29 - Better solution
    08:07 - Complexity
    08:21 - Optimal Solution
    08:41 - Prefix sum concept
    09:35 - Example
    13:55 - Dry run
    21:22 - Code
    22:38 - Complexity

  • @reshusingh3558
    @reshusingh3558 Год назад

    understood sir ,great explanation

  • @NazeerBashaShaik
    @NazeerBashaShaik 3 месяца назад

    Understood, thank you.

  • @gamengoaituyen4432
    @gamengoaituyen4432 Год назад

    tks for explanation, you are savior

  • @RaviKumar-sn6tu
    @RaviKumar-sn6tu 3 месяца назад +1

    understood captain...thanks

  • @rajatpatra2593
    @rajatpatra2593 Год назад +2

    Understood ❤️

  • @prigo333
    @prigo333 3 месяца назад +1

    you are awesome bhaiya...

  • @AniketKumar-hf2bo
    @AniketKumar-hf2bo 5 месяцев назад

    understood ,thnx for amazing video ❤❤❤❤❤❤

  • @lakshmiprasanna7058
    @lakshmiprasanna7058 Год назад +1

    Understood 💯💯💯

  • @kunwar-nw5dd
    @kunwar-nw5dd Год назад

    solution blew my mind

  • @NitinKumar-wm2dg
    @NitinKumar-wm2dg Год назад

    Thanks bhaiya, understood

  • @AnkitKumar-sz3by
    @AnkitKumar-sz3by 10 месяцев назад

    thanks really good explination

  • @saddubhaiii
    @saddubhaiii 24 дня назад

    Thank you Striver. I owe you❤

  • @code710
    @code710 Год назад +6

    Hi bhaiya it would be really helpful if you can give similar question links for practise after every question explanation!!

  • @parshchoradia9909
    @parshchoradia9909 Год назад

    Understood Sir!

  • @konankikeerthi
    @konankikeerthi Месяц назад

    Thanks bro. Understood

  • @nopecharon
    @nopecharon 11 месяцев назад +1

    you are topG of DSA

  • @OnstreamGaming
    @OnstreamGaming Месяц назад

    Thanks for the help raj bhaiya

  • @rakshanaravindran9809
    @rakshanaravindran9809 10 месяцев назад

    Thank you!!

  • @deepanshuverma6237
    @deepanshuverma6237 Месяц назад

    Regarding putting (0,1) int the Hashmap initally :
    Let consider somehow the preSum got exactly equal to our k, means now the sub-array till that presum element gives us the k (~ preSum-k = 0).
    means whenever we find our preSum touching the k value, we need to increment count but we will not be able to find it in hashMap as it is yet to be inserted that why
    either increment count based on if preSum-k = 0 or put a (0,1) in hashmap to automatically finding preSum-k = 0 in the hashMap.
    int preSum = 0, count = 0, start = 0;
    Map mp = new HashMap();
    for(int i=0;i

  • @YourCodeVerse
    @YourCodeVerse 8 месяцев назад

    Understood✅🔥🔥

  • @swapnilingale4164
    @swapnilingale4164 10 месяцев назад

    Nice explation ❤

  • @ashj1165
    @ashj1165 6 месяцев назад

    though I am still figuring out on the map[0]=1 part but surely the rest of the part was indeed clear. thanks for these videos.

    • @JUST_C0DE
      @JUST_C0DE 5 месяцев назад

      if you select no element in sub array then , map[0]=1

  • @samyakagarwal1777
    @samyakagarwal1777 3 месяца назад

    thank you so much

  • @user-is6ky7pp2n
    @user-is6ky7pp2n Месяц назад

    Understood !! 😍😍

  • @schan263
    @schan263 8 месяцев назад

    Thanks for the great video. I don't see how I can come up with the optimal solution during the interview without hint from the interviewer.

  • @ayanangshudasmajumder112
    @ayanangshudasmajumder112 Год назад +4

    if instead of specifying map[0]=1 in the beginning if we give a condition that if(preSum == k) { count ++;}
    Will it be correct Striver bhaiya??

  • @shobhitsrivastava1223
    @shobhitsrivastava1223 11 месяцев назад

    Understood ❤

  • @her_soulmate
    @her_soulmate 10 месяцев назад

    Understood 🎉

  • @kingbadshah452
    @kingbadshah452 5 месяцев назад

    understood striver thanks

  • @UtkarshSingh575
    @UtkarshSingh575 3 месяца назад +1

    Understood!

  • @sarangkumarsingh7901
    @sarangkumarsingh7901 4 месяца назад

    Awesome Awesome Sir...............

  • @mozsty
    @mozsty 2 месяца назад

    very nice. .thankyou

  • @DTALKS01
    @DTALKS01 29 дней назад

    for me optimal is little hard but after see 2-3 time video , got easly understand

  • @YerramArun
    @YerramArun Год назад

    Understood❤❤

  • @user-sp8ne7hj3n
    @user-sp8ne7hj3n 7 месяцев назад

    nice ..........explanation

  • @aashapun6533
    @aashapun6533 7 месяцев назад

    The Best♥

  • @anuragroy9045
    @anuragroy9045 11 месяцев назад

    understood!!!

  • @VineetKumar-fk2rl
    @VineetKumar-fk2rl 8 месяцев назад +1

    We can also solve this problem in O(1) space complexity but the T.C will be 2N using two pointer approach.

  • @satyam5613
    @satyam5613 3 месяца назад

    thank you

  • @culeforever5408
    @culeforever5408 8 месяцев назад +1

    undestood ✌

  • @mriduljain1981
    @mriduljain1981 10 месяцев назад

    we can also use sliding window 2 pointer approach for this one code->
    int findAllSubarraysWithGivenSum(vector < int > & arr, int k) {
    int n =arr.size(),sum = 0,cnt = 0,left = 0;
    for(int right = 0;right k) sum-=arr[left++];
    if(sum == k) cnt++;
    }
    return cnt;
    }

    • @amitranjan6998
      @amitranjan6998 10 месяцев назад

      It will fail .arr[]=[1] k=0

    • @mriduljain1981
      @mriduljain1981 10 месяцев назад

      @@amitranjan6998 yes we just need to add a condition of left

  • @chinmay6152
    @chinmay6152 Год назад

    Understood😁😉

  • @user-nk1mb5fy7j
    @user-nk1mb5fy7j Год назад

    UNDERSTOOD

  • @biswadevsarkar2830
    @biswadevsarkar2830 Месяц назад

    mpp[0] = 1 helps us to take the count when (sum == k ). Because when sum will be k, then remove will be 0. And then mpp[1] will give us 0, which will be added to the count. If we don't store 0 to our map. then we need to handle the case in an extra if condtion. which is if(sum == k) count++;

  • @rohan8758
    @rohan8758 2 месяца назад

    Awesome explanation, one approach of sliding window will not work in this problem if array contains negative elements also.

  • @saicharanthammi143
    @saicharanthammi143 4 месяца назад

    Thanku sir

  • @Hariharan0606
    @Hariharan0606 Год назад

    Amazing

  • @user-uv5or5bm2c
    @user-uv5or5bm2c 5 месяцев назад

    Understood.

  • @nikiteshnandale8264
    @nikiteshnandale8264 Год назад +4

    It seems like you have edited your voice in the video and made it soft, I am missing that bold voice which is there in the DP playlist. Please don't edit your voice, you don't have to adjust yourself for us. We like the way you are, the original STRIVER🔥🔥

    • @takeUforward
      @takeUforward  Год назад +13

      But we need to look at the future, we want to go global, so audio quality has to be maintained, I hope you get that :)

    • @abdulrehmaan153
      @abdulrehmaan153 Год назад

      ​@@takeUforwardand we love you for that too,
      It's sort of unconditional 😂

  • @piyushnandardhane1432
    @piyushnandardhane1432 Год назад

    Please also make video for count pairs with given sum and divisible by k

  • @gagan_.hegde14
    @gagan_.hegde14 2 месяца назад

    underrstood

  • @user-sm7zo5zd9t
    @user-sm7zo5zd9t 4 месяца назад +1

    Understood

  • @saileshsirari2014
    @saileshsirari2014 Месяц назад

    Without adding to map, you need to count occurrences still not in map
    public int subarraySum(int[] nums, int k) {
    int sum=0;
    int count =0;
    Map map = new HashMap();
    for(int i=0;i

  • @impalash_ag
    @impalash_ag 19 дней назад

    Storing (0,1) in the hashmap is bit confusing, instead we can just increase a check i.e. if(currSum == k) count++. The more readable code(JAVA) will look like this:
    public int subarraySum(int[] nums, int k) {
    int currSum = 0, count = 0;
    int n = nums.length;
    HashMap map = new HashMap();
    for(int i=0; i

  • @Hustler0109
    @Hustler0109 Год назад +5

    Striver you can make these playlists a bit fun if you allow your viewers to suggest you problems they think discussable !!
    btw loving the playlist

  • @PranaliAwhale
    @PranaliAwhale Месяц назад +1

    understood

  • @nishantkumar1276
    @nishantkumar1276 Год назад

    Sir, May I know time complexity of the optimal approach in java

  • @shaiksoofi3741
    @shaiksoofi3741 5 месяцев назад

    tq

  • @meghnakhaitan2495
    @meghnakhaitan2495 Год назад +1

    Can you pls pls plsssss do strings before binary search next plsss🙏 ? From 2023 batch🥺. Wish we could have the entire series in our 1st 2nd 3rd yrs

  • @VnALShorts
    @VnALShorts Год назад

    22:54 *please explain what lines*
    int remove = presum - k;
    count += mp[remove];
    mp[presum]++;
    do ?

  • @opgaming-sl8ze
    @opgaming-sl8ze Год назад

    Bhaiya ye Question ka video dekhne se phale hoo gaya 😁😁Only Minor change
    int findAllSubarraysWithGivenSum(vector < int > & nums, int k) {
    int right = 0;
    int left = 0;
    int count = 0;
    long long sum = nums[0];
    int n = nums.size();
    while(right < n){
    while(left k){
    sum = sum - nums[left];
    left++;
    }
    if(sum == k){
    count++;
    }
    right++;
    if(right < n){
    sum+=nums[right];
    }
    }
    return count;
    }

  • @Rishabh3164
    @Rishabh3164 8 месяцев назад

    Can we do this first calculate the prefix sum and than suffix sum and than we subtract each and sum the prefix and suffix

  • @AdityaKumar-ow1rh
    @AdityaKumar-ow1rh Год назад

    we can also do this problem by sliding window technique

  • @mriduljain6809
    @mriduljain6809 Год назад

    Can also do like this:
    int subarraySum(vector& nums, int k) {
    unordered_map m;
    int c = 0;
    int s=0;
    for(int i=0;i

  • @nookalareshwanth1785
    @nookalareshwanth1785 6 месяцев назад

    nice

  • @rowgha2710
    @rowgha2710 10 месяцев назад +1

    What if the array contains 0s?

  • @AbhishekKumar-cd4gg
    @AbhishekKumar-cd4gg 8 месяцев назад

    understood , but took tom much time to understood how to update the frequency if there exist a prefix sum in the HashMap

  • @shubhambhardwaj8982
    @shubhambhardwaj8982 Год назад

    Hey Strivers Good explanation ❤
    Can you just change the gfg link of this question it redirect to same page.
    Once again thank you 👍

  • @sahilnayak9000
    @sahilnayak9000 6 месяцев назад


    You mentioned performing a dry run on the array [3, -3, 1, 1, 1] to understand the significance of initially putting (0, 1) in the map. However, it hasn't been specified which sum we should consider for this particular dry run.

    • @sahilnayak9000
      @sahilnayak9000 6 месяцев назад

      Although i understood,
      if we didn't want to put initially that or if we find it challenging to understand its significance.
      there is an alternative approach to handle the situation.
      Another way is when currentSum - given_sum == 0 we just need to increment counter.
      that's it we can omit to put initially (0,1) pair in map.

  • @RohitRaj-hl6ji
    @RohitRaj-hl6ji Год назад

    Why updating the map?? Can someone explain?